//____________________________________________________________________________
/*!

\program gevgen_faser

\brief  A GENIE v+A event generation driver customized for FASER (gevgen_faser).

        (Based on gevgen and gevgen_t2k)

         This driver can handle the FASER neutrino flux files generated by Felix Kling and the
         realistic detector geometries / target mix of the FASER detector.

         FASER users should note that the generic GENIE event generation driver (gevgen) may
         still be a more appropriate tool to use for the simpler event generation cases
         required for many 4-vector level / systematic studies.
         Please see the GENIE documentation (http://www.genie-mc.org) if in doubt.

         Syntax :
           gevgen_faser [-h]
                        [-r run#]
                         -f flux_file
                         -g geometry
                         --cross-sections xml_file
                        [-n number_of_events_to_generate]
                        [-l luminosity_to_generate]
                        [-L flux_file_lumi_norm]
                        [-o outfile_prefix]
                        [--seed random_number_seed]
                        [-t top_volume_name_at_geom || -t +Vol1-Vol2...]  
                        [-m max_path_lengths_xml_file]
                        [--tune genie_tune]
                        [--message-thresholds xml_file]
                        [--unphysical-event-mask mask]
                        [--event-record-print-level level]
                        [--mc-job-status-refresh-rate  rate]
                        [--cache-file root_file]
                        [--xml-path config_xml_dir]

         Options :
           [] Denotes an optional argument.
           -h
              Prints-out help on using gevgen and exits.
           -r
              Specifies the MC run number.
           -f
              Specifies a ROOT file with the neutrino flux spectra.
              The contents of the file are inspected to determine whether it contains either:
                A gSimpleNtpFlux tree, or
                Flux histograms.
                  The flux histograms are assumed to be named:
                    NuE
                    NuMu
                    NuTau
                    AntiNuE
                    AntiNuMu
                    AntiNuTau
                  The histogram neutrino directions are parallel to the z-axis.
                  The histogram neutrinos start on a 50 cm radius disk at z = -3000 mm.
           -g
              Input 'geometry'.
              This option can be used to specify any of:
              1 > A gdml or root file containing a ROOT/GEANT geometry description
              2 > A mix of target materials, each with its corresponding weight,
                  typed as a comma-separated list of nuclear PDG codes (in the
                  std PDG2006 convention: 10LZZZAAAI) with the weight fractions
                  in brackets, eg code1[fraction1],code2[fraction2],...
                  If that option is used (no detailed input geometry description)
                  then the interaction vertices are distributed in the detector
                  by the detector MC.
                  [Examples]
                  - To use a target mix of 95% O16 and 5% H type:
                    '-g 1000080160[0.95],1000010010[0.05]'
                  - To use a target which is 100% C12, type:
                    '-g 1000060120'
           --cross-sections
              Name (incl. full path) of an XML file with pre-computed
              cross-section values used for constructing splines.
           -n
              Specifies the number of events to generate.
              Either the number of events or the integrated luminosity to simulate
              must be specifed.
           -l
              Specifies the integrated luminosity (in inverse femtobarns) to simulate.
              Either the number of events or the integrated luminosity to simulate
              must be specifed.
           -L
              Specifies the integrated luminosity normalization (in inverse femtobarns)
              of flux histograms. (Default: 150.0)
              Ignored for flux ntuples.
           -o
              Sets the prefix of the output event file.
              The output filename is built as:
              [prefix].[run_number].[event_tree_format].[file_format]
              The default output filename is:
              gntp.[run_number].ghep.root
              This cmd line arguments lets you override 'gntp'
           --seed
              Random number seed.
           -t
              Input 'top volume' for event generation -
              can be used to force event generation in given sub-detector.
              [default: the 'master volume' of the input geometry]
              You can also use the -t option to switch generation on/off at
              multiple volumes as, for example, in:
              `-t +Vol1-Vol2+Vol3-Vol4',
              `-t "+Vol1 -Vol2 +Vol3 -Vol4"',
              `-t -Vol2-Vol4+Vol1+Vol3',
              `-t "-Vol2 -Vol4 +Vol1 +Vol3"'m
              where:
              "+Vol1" and "+Vol3" tells GENIE to `switch on'  Vol1 and Vol3, while
              "-Vol2" and "-Vol4" tells GENIE to `switch off' Vol2 and Vol4.
              If the very first character is a '+', GENIE will neglect all volumes
              except the ones explicitly turned on. Vice versa, if the very first
              character is a `-', GENIE will keep all volumes except the ones
              explicitly turned off (feature contributed by J.Holeczek).
           -m
              An XML file (generated by gmxpl) with the max (density weighted)
              path-lengths for each target material in the input ROOT geometry.
              If no file is input, then the geometry will be scanned at MC job
              initialization to determine those max path lengths.
              Supplying this file can speed-up the MC job initialization.
           --event-generator-list
              List of event generators to load in event generation drivers.
              [default: "Default"].
           --tune
              Specifies a GENIE comprehensive neutrino interaction model tune.
              [default: "Default"].
           --message-thresholds
              Allows users to customize the message stream thresholds.
              The thresholds are specified using an XML file.
              See $GENIE/config/Messenger.xml for the XML schema.
           --unphysical-event-mask
              Allows users to specify a 16-bit mask to allow certain types of
              unphysical events to be written in the output file.
              [default: all unphysical events are rejected]
           --event-record-print-level
              Allows users to set the level of information shown when the event
              record is printed in the screen. See GHepRecord::Print().
           --mc-job-status-refresh-rate
              Allows users to customize the refresh rate of the status file.
           --cache-file
              Allows users to specify a cache file so that the cache can be
              re-used in subsequent MC jobs.
           --xml-path
              A directory to load XML files from - overrides $GXMLPATH, and $GENIE/config

        ***  See the User Manual for more details and examples. ***

\author  Costas Andreopoulos <costas.andreopoulos \at stfc.ac.uk>
         University of Liverpool & STFC Rutherford Appleton Lab
\author  Dave Casper <dcasper \at uci.edu>
         Eli Welch <welchem \at uci.edu>
         University of California, Irvine

\created Decemeber 11, 2021

\cpright Copyright (c) 2003-2021, The GENIE Collaboration
         For the full text of the license visit http://copyright.genie-mc.org
         or see $GENIE/LICENSE
*/
//____________________________________________________________________________

#include <cstdlib>
#include <cassert>
#include <sstream>
#include <string>
#include <vector>
#include <map>

// #if defined(HAVE_FENV_H) && defined(HAVE_FEENABLEEXCEPT)
// #include <fenv.h> // for `feenableexcept`
// #endif

#include <TFile.h>
#include <TTree.h>
#include <TSystem.h>
#include <TVector3.h>
#include <TH1.h>
#include <TF1.h>

// #include "Framework/Conventions/XmlParserStatus.h"
#include "Framework/Conventions/Constants.h"
#include "Framework/Conventions/GBuild.h"
#include "Framework/Conventions/Controls.h"
#include "Framework/Conventions/Units.h"
#include "Framework/EventGen/EventRecord.h"
#include "Framework/EventGen/GFluxI.h"
// #include "Framework/EventGen/GEVGDriver.h"
#include "Framework/EventGen/FaserGMCJDriver.h"
#include "Framework/EventGen/GMCJMonitor.h"
// #include "Framework/Interaction/Interaction.h"
#include "Framework/Messenger/Messenger.h"
#include "Framework/Ntuple/NtpWriter.h"
#include "Framework/Ntuple/NtpMCFormat.h"
#include "Framework/Numerical/RandomGen.h"
// #include "Framework/Numerical/Spline.h"
#include "Framework/ParticleData/PDGLibrary.h"
#include "Framework/ParticleData/PDGCodes.h"
#include "Framework/ParticleData/PDGUtils.h"
#include "Framework/Utils/XSecSplineList.h"
#include "Framework/Utils/StringUtils.h"
#include "Framework/Utils/UnitUtils.h"
#include "Framework/Utils/AppInit.h"
#include "Framework/Utils/RunOpt.h"
#include "Framework/Utils/CmdLnArgParser.h"
#include "Framework/Utils/SystemUtils.h"
#include "Framework/Utils/PrintUtils.h"


#ifdef __GENIE_FLUX_DRIVERS_ENABLED__
#include "Tools/Flux/GCylindTH1Flux.h"
#include "Tools/Flux/GSimpleNtpFlux.h"
#endif

#ifdef __GENIE_GEOM_DRIVERS_ENABLED__
#include "Tools/Geometry/GeoUtils.h"
#include "Tools/Geometry/FaserROOTGeomAnalyzer.h"
#include "Tools/Geometry/PointGeomAnalyzer.h"
#endif

using std::string;
using std::vector;
using std::map;
using std::ostringstream;

using namespace genie;

void GetCommandLineArgs (int argc, char ** argv);
void Initialize         (void);
void PrintSyntax        (void);
void ParseGeometryOption(CmdLnArgParser& parser);
void ParseFluxOption    (CmdLnArgParser& parser);

//Default options (not modifiable)
string kDefOptGeomLUnits            = "mm";    // default geometry length units (not modifiable)
string kDefOptGeomDUnits            = "g_cm3"; // default geometry density units (not modifiable)
std::map<int,string> kDefFluxHistos = { { 12, "NuE" },
                                        { 14, "NuMu" },
                                        { 16, "NuTau" },
                                        { -12, "AntiNuE" },
                                        { -14, "AntiNuMu" },
                                        { -16, "AntiNuTau" }
                                      };
double kDefOptStartPosLng           = -5.5; // neutrino longitudinal (z) start position (in m?) for histogram fluxes
double kDefOptTransRad              = 1.00;   // radius of neutrino start plane (in m?) for histogram fluxes
string kDefFluxTree                 = "flux";  // name of gSimpleNtpFlux flux tree
string kDefMetaTree                 = "meta";  // name of gSimpleNtpFlux meta tree

//Default options (override them using the command line arguments):
int           kDefOptNevents   = 0;          // n-events to generate
double        kDefOptFluxNorm     = 150.0;   // std LHC flux norm (inverse fb) for histograms
NtpMCFormat_t kDefOptNtpFormat = kNFGHEP;    // ntuple format
Long_t        kDefOptRunNu     = 0;          // default run number
string        kDefOptEvFilePrefix = "gntp";  // Output file name prefix


//User-specified options:
Long_t          gOptRunNu;                     // run number
int             gOptNevents;                   // n-events to generate
double          gOptLuminosity;                // integrated luminosity to generate (fb^-1)
long int        gOptNeutrinosToThrow;          // integrated neutrino flux when luminosity normalized
double          gOptFluxNorm;                  // normalization of flux histograms (fb^-1)
bool            gOptUsingRootGeom = false;     // using root geom or target mix?
string          gOptFluxFile;                  // ROOT file with flux histograms
map<int,double> gOptTgtMix;                    // target mix  (tgt pdg -> wght frac) / if not using detailed root geom
map<int,TH1D*>  gOptFluxHst;                   // flux histos (nu pdg  -> spectrum) 
vector<string>  gOptFluxTree;                  // GSimpleNtpFlux files
bool            gOptUsingFluxHst = false;
bool            gOptUsingFluxTree = false;
string          gOptFluxDriver = "";           // Flux driver name
string          gOptRootGeom;                  // input ROOT file with realistic detector geometry
string          gOptRootGeomTopVol = "";       // input geometry top event generation volume
double          gOptGeomLUnits = 0;            // input geometry length units
double          gOptGeomDUnits = 0;            // input geometry density units
string          gOptExtMaxPlXml;               // max path lengths XML file for input geometry
string          gOptEvFilePrefix;              // event file prefix
long int        gOptRanSeed;                   // random number seed
string          gOptInpXSecFile;               // cross-section splines

//____________________________________________________________________________
int main(int argc, char ** argv)
{
  GetCommandLineArgs(argc,argv);
  Initialize();

  // throw on NaNs and Infs...
#if defined(HAVE_FENV_H) && defined(HAVE_FEENABLEEXCEPT)
  feenableexcept(FE_DIVBYZERO | FE_INVALID | FE_OVERFLOW);
#endif

  GeomAnalyzerI * geom_driver = 0;
  double zmin=0, zmax=0;

  if(gOptUsingRootGeom) 
  {
    //
    // *** Using a realistic root-based detector geometry description
    //
    geometry::FaserROOTGeomAnalyzer * rgeom =
            new geometry::FaserROOTGeomAnalyzer(gOptRootGeom);
    rgeom -> SetLengthUnits  (gOptGeomLUnits);
    rgeom -> SetDensityUnits (gOptGeomDUnits);
    // getting the bounding box dimensions, before setting topvolume,
    // along z so as to set the appropriate upstream generation surface
    // for the JPARC flux driver
    TGeoVolume * topvol = rgeom->GetGeometry()->GetTopVolume();
    TGeoShape * bounding_box = topvol->GetShape();
    bounding_box->GetAxisRange(3, zmin, zmax);
    zmin *= rgeom->LengthUnits();
    zmax *= rgeom->LengthUnits();
    // now update to the requested topvolume for use in recursive exhaust method
    rgeom -> SetTopVolName   (gOptRootGeomTopVol);
    topvol = rgeom->GetGeometry()->GetTopVolume();
    if(!topvol) {
      LOG("gevgen_faser", pFATAL) << "Null top ROOT geometry volume!";
      exit(1);
    }
    // switch on/off volumes as requested
    if ( (gOptRootGeomTopVol[0] == '+') || (gOptRootGeomTopVol[0] == '-') ) {
      bool exhaust = (*gOptRootGeomTopVol.c_str() == '+');
      utils::geometry::RecursiveExhaust(topvol, gOptRootGeomTopVol, exhaust);
    }
    geom_driver = dynamic_cast<GeomAnalyzerI *> (rgeom);
  }
  else 
  {
    //
    // *** Using a 'point' geometry with the specified target mix
    // *** ( = a list of targets with their corresponding weight fraction)
    //
    geometry::PointGeomAnalyzer * pgeom =
              new geometry::PointGeomAnalyzer(gOptTgtMix);
    geom_driver = dynamic_cast<GeomAnalyzerI *> (pgeom);
  }

  // *************************************************************************
  // * Create / configure the flux driver
  // *************************************************************************
  GFluxI * flux_driver = 0;
  flux::GCylindTH1Flux * hst_flux_driver   = 0;
  flux::GSimpleNtpFlux* ntp_flux_driver = 0;
  double integratedFlux = 0.0;
  if (gOptFluxHst.size() > 0)
  {
    TVector3 bdir (0,0,1); // dir along +z
    TVector3 bspot(0,0,kDefOptStartPosLng);
    hst_flux_driver = new flux::GCylindTH1Flux;
    hst_flux_driver->SetNuDirection      (bdir);
    hst_flux_driver->SetBeamSpot         (bspot);
    hst_flux_driver->SetTransverseRadius (kDefOptTransRad);
    map<int,TH1D*>::iterator it = gOptFluxHst.begin();
    for( ; it != gOptFluxHst.end(); ++it) {
        int    pdg_code = it->first;
        if (gOptLuminosity > 0)
          integratedFlux += it->second->Integral("width");
        TH1D * spectrum = new TH1D(*(it->second));
        hst_flux_driver->AddEnergySpectrum(pdg_code, spectrum);
    }
    flux_driver = dynamic_cast<GFluxI *> (hst_flux_driver);
    gOptUsingFluxHst = true;
  }
  else if (gOptFluxTree.size() > 0)
  {
    ntp_flux_driver = new flux::GSimpleNtpFlux;
    ntp_flux_driver->LoadBeamSimData(gOptFluxTree, "");
    flux_driver = dynamic_cast<GFluxI*> (ntp_flux_driver);
    gOptUsingFluxTree = true;
  }
  // these might come in handy ... avoid repeated dynamic_cast<> calls
  genie::flux::GFluxExposureI* fluxExposureI =
    dynamic_cast<genie::flux::GFluxExposureI*>(flux_driver);
  genie::flux::GFluxFileConfigI* fluxFileConfigI =
    dynamic_cast<genie::flux::GFluxFileConfigI*>(flux_driver);


  // *************************************************************************
  // * Create/configure the event generation driver
  // *************************************************************************
  FaserGMCJDriver * mcj_driver = new FaserGMCJDriver;
  mcj_driver->SetEventGeneratorList(RunOpt::Instance()->EventGeneratorList());
  mcj_driver->UseFluxDriver(flux_driver);
  mcj_driver->UseGeomAnalyzer(geom_driver);
  mcj_driver->UseMaxPathLengths(gOptExtMaxPlXml);
  mcj_driver->Configure();
  mcj_driver->UseSplines();
  mcj_driver->ForceSingleProbScale();

  // *************************************************************************
  // * Work out number of neutrinos for current exposure settings
  // *************************************************************************
  if (gOptLuminosity > 0)
  {
    LOG("gevgen_faser", pINFO) << "Luminosity normalization requested was "
      << gOptLuminosity << " inverse femtobarns";
    if (gOptFluxHst.size() != 0)
    {
      // Flux histograms are per cm^2
      integratedFlux *= constants::kPi * pow( 100.0 * kDefOptTransRad, 2);
      integratedFlux *= gOptLuminosity/gOptFluxNorm;
      gOptNeutrinosToThrow = lround(integratedFlux * mcj_driver->GlobProbScale());
      LOG("gevgen_faser", pINFO) << "Throwing " 
        << gOptNeutrinosToThrow << " neutrinos in luminosity-normalized histogram flux mode";
    }
  }

  // *************************************************************************
  // * Prepare for writing the output event tree & status file
  // *************************************************************************

  // Initialize an Ntuple Writer to save GHEP records into a TTree
  NtpWriter ntpw(kDefOptNtpFormat, gOptRunNu);
  ntpw.CustomizeFilenamePrefix(gOptEvFilePrefix);
  ntpw.Initialize();

  // Create a MC job monitor for a periodically updated status file
  GMCJMonitor mcjmonitor(gOptRunNu);
  mcjmonitor.SetRefreshRate(RunOpt::Instance()->MCJobStatusRefreshRate());

  // *************************************************************************
  // * Event generation loop
  // *************************************************************************

  int ievent = 0;
  bool moreNeutrinos = true;
  while (moreNeutrinos)
  {
     LOG("gevgen_faser", pNOTICE)
          << " *** Generating event............ " << ievent;

     // In case the required statistics was expressed as 'number of events'
     // then quit if that number has been generated
     if(ievent == gOptNevents) break;

     // Generate a single event using neutrinos coming from the specified flux
     // and hitting the specified geometry or target mix
     EventRecord * event = mcj_driver->GenerateEvent();

     // If we needed more neutrinos than the requested luminosity, reject the event
     moreNeutrinos = (gOptLuminosity <= 0 || 
      (gOptUsingFluxHst && (mcj_driver->NFluxNeutrinos() <= gOptNeutrinosToThrow)) ||
      (gOptUsingFluxTree && (ntp_flux_driver->GetTotalExposure()/mcj_driver->GlobProbScale() <= gOptLuminosity)));
     if (moreNeutrinos)
     {
      LOG("gevgen_faser", pINFO)
         << "Generated event: " << *event;

      // Add event at the output ntuple, refresh the mc job monitor & clean-up
      ntpw.AddEventRecord(ievent, event);
      mcjmonitor.Update(ievent,event);
      ievent++;
     }
     delete event;
  } //1

  LOG("gevgen_faser", pNOTICE)
    << "The GENIE MC job is done generaing events - Cleaning up & exiting...";

  // *************************************************************************
  // * Print job statistics &
  // * calculate normalization factor for the generated sample
  // *************************************************************************
  if ( !gOptUsingFluxHst && gOptUsingRootGeom ) {
    // POT normalization will only be calculated if event generation was based
    // on beam simulation ntuples (not just histograms) & a detailed detector
    // geometry description.
    // Get nunber of flux neutrinos read-in by flux driver, number of flux
    // neutrinos actually thrown to the event generation driver and number
    // of neutrino interactions actually generated
    long int nflx     = 0;
    long int nflx_evg = mcj_driver-> NFluxNeutrinos();
    double   fpot     = 0;
    const char* exposureUnits = "(unknown units)";
    if ( fluxExposureI ) {
      fpot = fluxExposureI->GetTotalExposure(); // POTs used so far
      nflx = fluxExposureI->NFluxNeutrinos();
      //genie::flux::Exposure_t etype = fluxExposureI->GetExposureType();
      //exposureUnits = genie::flux::GFluxExposureI::AsString(etype);
      exposureUnits = fluxExposureI->GetExposureUnits();
    }
    if ( fluxFileConfigI ) {
      fluxFileConfigI->PrintConfig();
    }
    double psc   = mcj_driver->GlobProbScale();      // interaction prob. scale
    if ( psc <= 0.0 ) {
       LOG("gevgen_faser", pFATAL) << "MCJobDriver GlobalProbScale was " << psc;
    }
    double pot   = fpot / psc;                       // POT for generated sample
    long int nev = ievent;

    LOG("gevgen_faser", pNOTICE)
        << "\n >> Interaction probability scaling factor:  " << psc
        << "\n >> using: " << gOptFluxDriver << " driver"
        << "\n >> N of flux v read-in by flux driver:      " << nflx
        << "\n >> N of flux v thrown to event gen driver:  " << nflx_evg
        << "\n >> N of generated v interactions:           " << nev
        << "\n ** Normalization for generated sample:      " << pot
        << " " << exposureUnits << " * detector";

    ntpw.EventTree()->SetWeight(pot); // store POT
  }

  // *************************************************************************
  // * Save & clean-up
  // *************************************************************************

  // Save the generated event tree & close the output file
  ntpw.Save();

  // Clean-up
  delete geom_driver;
  delete flux_driver;
  delete mcj_driver;
  map<int,TH1D*>::iterator it = gOptFluxHst.begin();
  for( ; it != gOptFluxHst.end(); ++it) {
    TH1D * spectrum = it->second;
    if(spectrum) delete spectrum;
  }
  gOptFluxHst.clear();
  gOptFluxTree.clear();

  LOG("gevgen_faser", pNOTICE) << "Done!";

  return 0;
}
//____________________________________________________________________________
void Initialize()
{

  if ( ! RunOpt::Instance()->Tune() ) {
    LOG("gevgen_faser", pFATAL) << " No TuneId in RunOption";
    exit(-1);
  }
  RunOpt::Instance()->BuildTune();

  // Initialization of random number generators, cross-section table,
  // messenger thresholds, cache file
  utils::app_init::MesgThresholds(RunOpt::Instance()->MesgThresholdFiles());
  utils::app_init::CacheFile(RunOpt::Instance()->CacheFile());
  utils::app_init::RandGen(gOptRanSeed);
  utils::app_init::XSecTable(gOptInpXSecFile, false);

  // Set GHEP print level
  GHepRecord::SetPrintLevel(RunOpt::Instance()->EventRecordPrintLevel());
}
//____________________________________________________________________________
void GetCommandLineArgs(int argc, char ** argv)
{
  LOG("gevgen_faser", pINFO) << "Parsing command line arguments";

  // Common run options. Set defaults and read.
  RunOpt::Instance()->EnableBareXSecPreCalc(true);
  RunOpt::Instance()->ReadFromCommandLine(argc,argv);

  // Parse run options for this app

  CmdLnArgParser parser(argc,argv);

  // help?
  bool help = parser.OptionExists('h');
  if(help) {
      PrintSyntax();
      exit(0);
  }

  // flux file luminosity normalization
  // only relevant when using the JNUBEAM flux ntuples
  if( parser.OptionExists('L') ) {
    LOG("gevgen_faser", pDEBUG)  << "Reading flux file normalization";
    gOptFluxNorm = parser.ArgAsDouble('L');
  } else {
    LOG("gevgen_faser", pDEBUG)
        << "Setting standard normalization for flux histograms (if any)";
    gOptFluxNorm = kDefOptFluxNorm;
  } //-p

  // limit on max number of events that can be generated
  if( parser.OptionExists('n') ) {
    LOG("gevgen_faser", pDEBUG)
        << "Reading limit on number of events to generate";
    gOptNevents = parser.ArgAsInt('n');
  } else {
    LOG("gevgen_faser", pDEBUG)
      << "Will generate events until specified luminosity is reached";
    gOptNevents = -1;
  } //-n

  // exposure (in inverse fb)
  if( parser.OptionExists('l') ) {
    LOG("gevgen_faser", pDEBUG)  << "Generating requested exposure in inverse fb";
    gOptLuminosity = parser.ArgAsDouble('l');
  } else {
    LOG("gevgen_faser", pDEBUG) << "No POT exposure was requested";
    gOptLuminosity = -1;
  } //-l

  // event file prefix
  if( parser.OptionExists('o') ) {
    LOG("gevgen_faser", pDEBUG) << "Reading the event filename prefix";
    gOptEvFilePrefix = parser.ArgAsString('o');
  } else {
    LOG("gevgen_faser", pDEBUG)
      << "Will set the default event filename prefix";
    gOptEvFilePrefix = kDefOptEvFilePrefix;
  } //-o

  // run number
  if( parser.OptionExists('r') ) {
    LOG("gevgen_faser", pINFO) << "Reading MC run number";
    gOptRunNu = parser.ArgAsLong('r');
  } else {
    LOG("gevgen_faser", pINFO) << "Unspecified run number - Using default";
    gOptRunNu = kDefOptRunNu;
  }

  // geometry
  ParseGeometryOption(parser);

  // flux
  ParseFluxOption(parser);

  // random number seed
  if( parser.OptionExists("seed") ) {
    LOG("gevgen_faser", pINFO) << "Reading random number seed";
    gOptRanSeed = parser.ArgAsLong("seed");
  } else {
    LOG("gevgen_faser", pINFO) << "Unspecified random number seed - Using default";
    gOptRanSeed = controls::kDefaultRandSeed;
  }

  // input cross-section file
  if( parser.OptionExists("cross-sections") ) {
    LOG("gevgen_faser", pINFO) << "Reading cross-section file";
    gOptInpXSecFile = parser.ArgAsString("cross-sections");
  } else {
    LOG("gevgen_faser", pINFO) << "Unspecified cross-section file";
    gOptInpXSecFile = "";
  }
  //
  //  "Sanity" check(s)
  //
  // If we don't use a detailed ROOT detector geometry (but just a target mix) then
  // don't accept luminosity as a way to control job statistics (not enough info is passed
  // in the target mix to compute luminosity & the calculation can be easily done offline)
  if(!gOptUsingRootGeom) {
    if(gOptLuminosity > 0) {
       LOG("gevgen_faser", pFATAL)
         << "You may not use the -l option "
         << "without a detailed detector geometry description input";
       exit(1);
    }
  }
  //
  // print-out the command line options
  //
  PDGLibrary * pdglib = PDGLibrary::Instance();

  ostringstream gminfo;
  if (gOptUsingRootGeom) {
    gminfo << "Using ROOT geometry - file: " << gOptRootGeom
           << ", top volume: "
           << ((gOptRootGeomTopVol.size()==0) ? "<master volume>" : gOptRootGeomTopVol)
           << ", max{PL} file: "
           << ((gOptExtMaxPlXml.size()==0) ? "<none>" : gOptExtMaxPlXml)
           << ", length  units: " << kDefOptGeomLUnits
           << ", density units: " << kDefOptGeomDUnits;
  } else {
    gminfo << "Using target mix - ";
    map<int,double>::const_iterator iter;
    for(iter = gOptTgtMix.begin(); iter != gOptTgtMix.end(); ++iter) {
          int    pdg_code = iter->first;
          double wgt      = iter->second;
          TParticlePDG * p = pdglib->Find(pdg_code);
          if(p) {
            string name = p->GetName();
            gminfo << "(" << name << ") -> " << 100*wgt << "% / ";
          }//p?
    }
  }

  ostringstream fluxinfo;
  fluxinfo << "Using flux histograms - ";
  map<int,TH1D*>::const_iterator iter;
  for(iter = gOptFluxHst.begin(); iter != gOptFluxHst.end(); ++iter) {
      int    pdg_code = iter->first;
      TH1D * spectrum = iter->second;
      TParticlePDG * p = pdglib->Find(pdg_code);
      if(p) {
        string name = p->GetName();
        fluxinfo << "(" << name << ") -> " << spectrum->GetName() << " / ";
      }//p?
    }

  ostringstream exposure;
  if(gOptLuminosity > 0)
      exposure << "Number of inverse fb = " << gOptLuminosity;
  if(gOptNevents > 0)
      exposure << "Number of events = " << gOptNevents;

  LOG("gevgen_faser", pNOTICE)
     << "\n\n"
     << utils::print::PrintFramedMesg("Faser event generation job configuration");

  LOG("gevgen_faser", pNOTICE)
     << "\n -  Run number: " << gOptRunNu
     << "\n -  Random number seed: " << gOptRanSeed
     << "\n - Using cross-section file: " << gOptInpXSecFile
     << "\n - Flux     @ " << fluxinfo.str()
     << "\n - Geometry @ " << gminfo.str()
     << "\n - Exposure @ " << exposure.str();

  LOG("gevgen_faser", pNOTICE) << *RunOpt::Instance();

}
//
void ParseGeometryOption(CmdLnArgParser& parser)
{
  string geom = "";
  string lunits, dunits;
  if( parser.OptionExists('g') ) {
    LOG("gevgen_faser", pDEBUG) << "Getting input geometry";
    geom = parser.ArgAsString('g');

    // is it a ROOT file that contains a ROOT geometry?
    bool accessible_geom_file =
            ! (gSystem->AccessPathName(geom.c_str()));
    if (accessible_geom_file) {
      gOptRootGeom      = geom;
      gOptUsingRootGeom = true;
    }
  } else {
      LOG("gevgen_faser", pFATAL)
        << "No geometry option specified - Exiting";
      PrintSyntax();
      exit(1);
  } //-g

  if(gOptUsingRootGeom) {
     // using a ROOT geometry - get requested geometry units

     // legth units:
    //  if( parser.OptionExists('L') ) {
    //     LOG("gevgen_faser", pDEBUG)
    //        << "Checking for input geometry length units";
    //     lunits = parser.ArgAsString('L');
    //  } else {
    //     LOG("gevgen_faser", pDEBUG) << "Using default geometry length units";
    //     lunits = kDefOptGeomLUnits;
    //  } // -L
    //  // density units:
    //  if( parser.OptionExists('D') ) {
    //     LOG("gevgen_faser", pDEBUG)
    //        << "Checking for input geometry density units";
    //     dunits = parser.ArgAsString('D');
    //  } else {
    //     LOG("gevgen_faser", pDEBUG) << "Using default geometry density units";
    //     dunits = kDefOptGeomDUnits;
    //  } // -D
     gOptGeomLUnits = genie::utils::units::UnitFromString(kDefOptGeomLUnits);
     gOptGeomDUnits = genie::utils::units::UnitFromString(kDefOptGeomDUnits);

     // check whether an event generation volume name has been
     // specified -- default is the 'top volume'
     if( parser.OptionExists('t') ) {
        LOG("gevgen_faser", pDEBUG) << "Checking for input volume name";
        gOptRootGeomTopVol = parser.ArgAsString('t');
     } else {
        LOG("gevgen_faser", pDEBUG) << "Using the <master volume>";
     } // -t

     // check whether an XML file with the maximum (density weighted)
     // path lengths for each detector material is specified -
     // otherwise will compute the max path lengths at job init
     if( parser.OptionExists('m') ) {
        LOG("gevgen_faser", pDEBUG)
              << "Checking for maximum path lengths XML file";
        gOptExtMaxPlXml = parser.ArgAsString('m');
     } else {
        LOG("gevgen_faser", pDEBUG)
           << "Will compute the maximum path lengths at job init";
        gOptExtMaxPlXml = "";
     } // -m
  } // using root geom?

  else {
    // User has specified a target mix.
    // Decode the list of target pdf codes & their corresponding weight fraction
    // (specified as 'pdg_code_1[fraction_1],pdg_code_2[fraction_2],...')
    // See documentation on top section of this file.
    //
    gOptTgtMix.clear();
    vector<string> tgtmix = utils::str::Split(geom,",");
    if(tgtmix.size()==1) {
         int    pdg = atoi(tgtmix[0].c_str());
         double wgt = 1.0;
         gOptTgtMix.insert(map<int, double>::value_type(pdg, wgt));
    } else {
      vector<string>::const_iterator tgtmix_iter = tgtmix.begin();
      for( ; tgtmix_iter != tgtmix.end(); ++tgtmix_iter) {
         string tgt_with_wgt = *tgtmix_iter;
         string::size_type open_bracket  = tgt_with_wgt.find("[");
         string::size_type close_bracket = tgt_with_wgt.find("]");
         if (open_bracket ==string::npos ||
             close_bracket==string::npos)
         {
             LOG("gevgen_faser", pFATAL)
                << "You made an error in specifying the target mix";
             PrintSyntax();
             exit(1);
         }
         string::size_type ibeg = 0;
         string::size_type iend = open_bracket;
         string::size_type jbeg = open_bracket+1;
         string::size_type jend = close_bracket;
         int    pdg = atoi(tgt_with_wgt.substr(ibeg,iend-ibeg).c_str());
         double wgt = atof(tgt_with_wgt.substr(jbeg,jend-jbeg).c_str());
         LOG("gevgen_faser", pDEBUG)
            << "Adding to target mix: pdg = " << pdg << ", wgt = " << wgt;
         gOptTgtMix.insert(map<int, double>::value_type(pdg, wgt));

      }// tgtmix_iter
    } // >1 materials in mix
  } // using tgt mix?
}

void ParseFluxOption(CmdLnArgParser& parser)
{
  //
  // *** flux
  //

  if( parser.OptionExists('f') ) {
    LOG("gevgen_faser", pDEBUG) << "Getting input flux";
    gOptFluxHst.clear();  // make sure list of histograms starts empty
    string flux = parser.ArgAsString('f');
    vector<string> fluxv = utils::str::Split(flux,",");

    // See if we have a comma-separated list of GSimpleNtpFlux files
    for (size_t iFile = 0; iFile < fluxv.size(); iFile++)
    {
      gOptFluxFile = fluxv[iFile];
      bool accessible_flux_file =
              !(gSystem->AccessPathName(gOptFluxFile.c_str()));
      if (!accessible_flux_file) {
          LOG("gevgen_faser", pDEBUG)
            << "Can not access flux file: " << gOptFluxFile << ". Looking for flux histograms instead.";
          gOptFluxTree.clear();
          break;
      }
      TFile flux_file(gOptFluxFile.c_str(), "read");
      // Check whether file contains trees expected by GSimpleNtpFlux
      TTree* iFluxTree = dynamic_cast<TTree*>(flux_file.Get(kDefFluxTree.c_str()));
      TTree* iMetaTree = dynamic_cast<TTree*>(flux_file.Get(kDefMetaTree.c_str()));
      flux_file.Close();
      if (iFluxTree != nullptr && iMetaTree != nullptr)
      {
        // Using flux tree(s)
        // Interpret comma-separated list as a list of GSimpleNtpFlux files
        gOptFluxTree.push_back(gOptFluxFile);
      }
      else
      {
        LOG("gevgen_faser", pDEBUG) << gOptFluxFile << " is not a valid GSimpleNtpFlux file. Looking for flux histograms instead.";
        gOptFluxTree.clear();
        break;
      }
    }

    if (!gOptFluxTree.empty()) 
    {
      gOptFluxDriver = "genie::flux::GSimpleNtpFlux";
      return; // Found GSimpleNtpFlux tree(s)
    }

    // Interpret flux option as a histogram file
    gOptFluxDriver = "genie::flux::GCylindTH1Flux";
    gOptFluxFile = fluxv[0];
    bool accessible_flux_file =
          !(gSystem->AccessPathName(gOptFluxFile.c_str()));
    if (!accessible_flux_file) {
        LOG("gevgen_faser", pFATAL)
          << "Can not access flux file: " << gOptFluxFile ;
        PrintSyntax();
        exit(1);
    }
    TFile flux_file(gOptFluxFile.c_str(), "read");
    if (fluxv.size() == 1)
    {
      // User has not specified the names of histograms for each species explicitly
      // Use the defaults
      for (auto entry : kDefFluxHistos)
      {
        int pdg = entry.first;
        string histo = entry.second;
        TH1D* ihst = (TH1D*) flux_file.Get(histo.c_str());
        if(!ihst) continue;
        TString origname = ihst->GetName();
        TString tmpname; tmpname.Form("%s_", origname.Data());
        TH1D * spectrum = new TH1D(
              tmpname.Data(), ihst->GetName(), ihst->GetNbinsX(),
              ihst->GetXaxis()->GetXmin(), ihst->GetXaxis()->GetXmax());
        spectrum->SetDirectory(0);
        for(int ibin = 1; ibin <= ihst->GetNbinsX(); ibin++) {
            spectrum->SetBinContent(ibin, ihst->GetBinContent(ibin));
        }
        // get rid of original
        delete ihst;
        // rename copy
        spectrum->SetName(origname.Data());

        // store flux neutrino code / energy spectrum
        LOG("gevgen_faser", pDEBUG)
          << "Adding energy spectrum for flux neutrino: pdg = " << pdg;
        gOptFluxHst.insert(map<int, TH1D*>::value_type(pdg, spectrum));
      }
      // Make sure we found at least one flux histogram
      if(gOptFluxHst.size()<1) {
        LOG("gevgen_faser", pFATAL)
            << "Your flux file contains no histograms with the expected names!";
        PrintSyntax();
        exit(1);
      }
    }
    else 
    {
      // Extract energy spectra for all specified neutrino species
      for(unsigned int inu=1; inu<fluxv.size(); inu++) {
        string nutype_and_histo = fluxv[inu];
        string::size_type open_bracket  = nutype_and_histo.find("[");
        string::size_type close_bracket = nutype_and_histo.find("]");
        if (open_bracket ==string::npos ||
            close_bracket==string::npos)
        {
            LOG("gevgen_faser", pFATAL)
               << "You made an error in specifying the flux histograms";
            PrintSyntax();
            exit(1);
        }
        string::size_type ibeg = 0;
        string::size_type iend = open_bracket;
        string::size_type jbeg = open_bracket+1;
        string::size_type jend = close_bracket;
        string nutype = nutype_and_histo.substr(jbeg,jend-jbeg);
        string histo  = nutype_and_histo.substr(ibeg,iend-ibeg);
        // access specified histogram from the input root file
        TH1D * ihst = (TH1D*) flux_file.Get(histo.c_str());
        if(!ihst) {
            LOG("gevgen_faser", pFATAL)
              << "Can not find histogram: " << histo
              << " in flux file: " << gOptFluxFile;
            PrintSyntax();
            exit(1);
        }
        // create a local copy of the input histogram
        TString origname = ihst->GetName();
        TString tmpname; tmpname.Form("%s_", origname.Data());
        TH1D * spectrum = new TH1D(
              tmpname.Data(), ihst->GetName(), ihst->GetNbinsX(),
              ihst->GetXaxis()->GetXmin(), ihst->GetXaxis()->GetXmax());
        spectrum->SetDirectory(0);
        for(int ibin = 1; ibin <= ihst->GetNbinsX(); ibin++) {
            spectrum->SetBinContent(ibin, ihst->GetBinContent(ibin));
        }
        // get rid of original
        delete ihst;
        // rename copy
        spectrum->SetName(origname.Data());

        // convert neutrino name -> pdg code
        int pdg = atoi(nutype.c_str());
        if(!pdg::IsNeutrino(pdg) && !pdg::IsAntiNeutrino(pdg)) {
            LOG("gevgen_faser", pFATAL)
                << "Unknown neutrino type: " << nutype;
            PrintSyntax();
            exit(1);
        }
        // store flux neutrino code / energy spectrum
        LOG("gevgen_faser", pDEBUG)
          << "Adding energy spectrum for flux neutrino: pdg = " << pdg;
        gOptFluxHst.insert(map<int, TH1D*>::value_type(pdg, spectrum));
      }//inu
      if(gOptFluxHst.size()<1) {
        LOG("gevgen_faser", pFATAL)
            << "You have not specified any flux histogram!";
        PrintSyntax();
        exit(1);
      }
    } // implicit or explicit histogram association?
    flux_file.Close();

  } else {
      LOG("gevgen_faser", pFATAL) << "No flux info was specified - Exiting";
      PrintSyntax();
      exit(1);
  }
}
//____________________________________________________________________________
void PrintSyntax(void)
{
  LOG("gevgen_faser", pNOTICE)
    << "\n\n" << "Syntax:" << "\n"
    << "\n      gevgen_faser [-h]"
    << "\n                   [-r run#]"
    << "\n                    -f flux_file"
    << "\n                    -g geometry"
    << "\n                   --cross-sections xml_file"
    << "\n                   [-n number_of_events_to_generate]"
    << "\n                   [-l luminosity_to_generate]"
    << "\n                   [-L flux_file_lumi_norm (default: 150 fb^-1)]"
    << "\n                   [-o outfile_prefix]"
    << "\n                   [--seed random_number_seed]"
    << "\n                   [-t top_volume_name_at_geom || -t +Vol1-Vol2...]"
    << "\n                   [-m max_path_lengths_xml_file]"
    << "\n                   [--tune genie_tune]"
    << "\n                   [--message-thresholds xml_file]"
    << "\n                   [--unphysical-event-mask mask]"
    << "\n                   [--event-record-print-level level]"
    << "\n                   [--mc-job-status-refresh-rate  rate]"
    << "\n                   [--cache-file root_file]"
    << "\n                   [--xml-path config_xml_dir]"
    << "\n";
}
//____________________________________________________________________________
